<?php
namespace Claromentis\Core\Acl\Simple;

$GLOBALS["__65da1b1ec2d6653e8a0ab7848e53621" . "5"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"] ?: array()) + array("_84718d828d2acc3c366f96b07e8" . "41f6a" => base64_decode("YWNs" . "LnNp" . "bXBs" . "ZQ=="), "_27de5a45db71bf24058769b61b39" . "75a3" => base64_decode("Q2FuJ3Qgc2F2ZSBBQ0w6IG9iamVjdCBjb2RlIG5vdCBzcGVjaWZpZW" . "Q="), "_80fc2a45acd0150df87d1f" . "b728940a60" => base64_decode("U0VMRUNUIHJpZ2h0cyBGUk9NIHNpbXBsZV9hY2wgV0" . "hFUkUgb2JqZWN0X2NvZGUgZXE6c3RyOmNvZGUgQU5E" . "IHVzZXJfaWQ9aW50OnVpZA=="), "_ef2948c87ef38aab9226e4" . "1189b29ca7" => base64_decode("REVMRVRFIEZST00gc2" . "ltcGxlX2FjbCBXSEVS" . "RSBvYmplY3RfY29kZS" . "BlcTpzdHI6Y29kZQ=="), "_a7ed4d7408b" . "b99b87a09d89" . "d4212d5de" => base64_decode("c2ltcGxlX" . "2FjbA=="), "_a8b22fedb27a11e07f5" . "bb9a7c73608ea" => base64_decode("c3RyKDE" . "wMCk6b2" . "JqZWN0X" . "2NvZGU="), "_3cda3f34a" . "da928e4aa3" . "9d4629c550" . "4aa" => base64_decode("aW50OnJpZ2h0cw=" . "="), "_c95cbc316178c97697a4" . "03f4d9124106" => base64_decode("U0VMRUNUIHVzZXJfaWQsIHJpZ2h0cyBGUk9NIHNpbXBsZV9hY2wgV0hFUkUgb2JqZWN" . "0X2NvZGUgZXE6c3RyOmNvZGU="), "_0877a0b48cf424a0de57a453c" . "e95e30c" => base64_decode("aW50OnVz" . "ZXJfaWQ="), "_b06968b92" . "68deaf3b38" . "0bd0fe922b" . "453" => base64_decode("REVMRVRFIEZST00gc2ltcGxlX2FjbCBXSEVSRSBvYmp" . "lY3RfY29kZSBlcTpzdHI6Y29kZSBBTkQgdXNlcl9pZD" . "1pbnQ6dWlk"), "_938704c4c0169c38" . "04d4bd6aa9941a76" => base64_decode("Q2FuJ3QgbG9hZCBBQ0w6IG9iamVjdCBjb2RlIG5vdCBzcGVj" . "aWZpZWQ="), "_dbbe14f567693a631f8a43b65af917" . "ab" => base64_decode("Q2FuJ3QgZGVsZXRlIEFDTCBmcm9tIGRhdGFiYXNl" . "OiBvYmplY3QgY29kZSBub3Qgc3BlY2lmaWVk"));
use Claromentis\Core\Acl\Exception\NoObjectException;
use Claromentis\Core\DAL;





class SimpleAclRepository
{
    private $db;
    public function __construct(DAL\Db $db)
    {
        $this->db = $db;
    }
    
    
    
    
    public static function I()
    {
        global $g_application;
        return $g_application[$GLOBALS["__65da1b1ec2d66" . "53e8a0ab7848e53" . "6215"]["_84718d828d2acc3c366f96b07e8" . "41f6a"]];
    }
    public function IsGranted(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD) : bool
    {
        if (!$user_id) {
            return false;
        }
        
        
        
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1ec2d6653" . "e8a0ab7848e536215"]["_80fc2a45acd0150df8" . "7d1fb728940a60"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
        if (!$_1f24efd4735b7a11b391147435e7d35d->hasData()) {
            return false;
        }
        list($p) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow();
        return ($p & $perms) == $perms;
    }
    public function Grant(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id, int $perms = SimpleAcl::STANDARD)
    {
        $this->db->query(new DAL\QueryInsert($GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_a7ed4d7408bb9" . "9b87a09d89d421" . "2d5de"], [$GLOBALS["__65da1b1ec2d6653e8a0ab784" . "8e536215"]["_a8b22fedb27a11e07f5bb" . "9a7c73608ea"] => $_65c616d6ef3c21352d2d44595fdf776b, $GLOBALS["__65da1b1ec2d6653e8a0ab7848e" . "536215"]["_0877a0b48cf424a0de57a453ce95" . "e30c"] => $user_id, $GLOBALS["__65da1b1ec2d6653e8a0ab7848" . "e536215"]["_3cda3f34ada928e4aa39d4629c5" . "504aa"] => $perms]));
    }
    public function Revoke(string $_65c616d6ef3c21352d2d44595fdf776b, int $user_id)
    {
        $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_b06968b9268deaf3b380" . "bd0fe922b453"], $_65c616d6ef3c21352d2d44595fdf776b, $user_id);
    }
    
    
    
    
    
    
    
    
    public function Get(string $_65c616d6ef3c21352d2d44595fdf776b) : SimpleAcl
    {
        $acl = new SimpleAcl($_65c616d6ef3c21352d2d44595fdf776b);
        $this->Load($acl);
        return $acl;
    }
    
    
    
    
    
    
    public function Load(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_938704c4c0169c3804d4b" . "d6aa9941a76"]);
        }
        $acl->Clear();
        $_1f24efd4735b7a11b391147435e7d35d = $this->db->query($GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"]["_c95cbc316178c97697a403f4d912" . "4106"], $acl->GetObjectCode());
        while (list($user_id, $perms) = $_1f24efd4735b7a11b391147435e7d35d->fetchRow()) {
            $acl->Set($user_id, $perms);
        }
    }
    
    
    
    
    public function Save(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_27de5a45db71bf24058769b61b3" . "975a3"]);
        }
        $this->Delete($acl);
        $_65c616d6ef3c21352d2d44595fdf776b = $acl->GetObjectCode();
        foreach ($acl->GetRights() as $user_id => $perms) {
            if ($perms) {
                $this->Grant($_65c616d6ef3c21352d2d44595fdf776b, $user_id, $perms);
            }
        }
    }
    
    
    
    
    
    
    public function Delete(SimpleAcl $acl)
    {
        if (!$acl->GetObjectCode()) {
            throw new NoObjectException($GLOBALS["__65da1b1" . "ec2d6653e" . "8a0ab7848" . "e536215"]["_dbbe14f567693a631f8a43b6" . "5af917ab"]);
        }
        $this->db->query($GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["_ef2948c" . "87ef38aa" . "b9226e41" . "189b29ca" . "7"], $acl->GetObjectCode());
    }
}